﻿using Infragistics.Win.UltraWinSchedule;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.SqlClient;
using System.Diagnostics;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WGV_MultipleProjects
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'database1DataSet.Owners' table. You can move, or remove it, as needed.
            this.ownersTableAdapter.Fill(this.database1DataSet.Owners);
            // TODO: This line of code loads data into the 'database1DataSet1.Tasks' table. You can move, or remove it, as needed.
            this.tasksTableAdapter.Fill(this.database1DataSet.Tasks);
            // TODO: This line of code loads data into the 'database1DataSet1.Project' table. You can move, or remove it, as needed.
            this.projectTableAdapter.Fill(this.database1DataSet.Project);

            GetData();

            ultraComboEditor1.DataSource = this.database1DataSet.Project;
            ultraComboEditor1.DisplayMember = "Project Name";
            ultraComboEditor1.ValueMember = "ProjectKey";
            ultraComboEditor1.Value = "FirstProject";
        }

        private void GetData()
        {
            this.ultraCalendarInfo1.DataBindingsForOwners.BindingContextControl = this;
            this.ultraCalendarInfo1.DataBindingsForTasks.BindingContextControl = this;
            this.ultraCalendarInfo1.DataBindingsForProjects.BindingContextControl = this;

            this.ultraCalendarInfo1.DataBindingsForOwners.SetDataBinding(database1DataSet, "Owners"); 
            this.ultraCalendarInfo1.DataBindingsForOwners.KeyMember = "Key";
            this.ultraCalendarInfo1.DataBindingsForOwners.AllPropertiesMember = "AllProperties";


            this.ultraCalendarInfo1.DataBindingsForProjects.SetDataBinding(database1DataSet, "Project");
            this.ultraCalendarInfo1.DataBindingsForProjects.IdMember = "ProjectID";
            this.ultraCalendarInfo1.DataBindingsForProjects.KeyMember = "ProjectKey";
            this.ultraCalendarInfo1.DataBindingsForProjects.NameMember = "Project Name";
            this.ultraCalendarInfo1.DataBindingsForProjects.StartDateMember = "StartDate";

            this.ultraCalendarInfo1.DataBindingsForTasks.SetDataBinding(database1DataSet, "Tasks");

            this.ultraCalendarInfo1.DataBindingsForTasks.NameMember = "TaskName";
            this.ultraCalendarInfo1.DataBindingsForTasks.DurationMember = "Duration";
            this.ultraCalendarInfo1.DataBindingsForTasks.StartDateTimeMember = "TaskStartDate";
            this.ultraCalendarInfo1.DataBindingsForTasks.IdMember = "TaskID";
            this.ultraCalendarInfo1.DataBindingsForTasks.ProjectKeyMember = "ProjektKey";
            this.ultraCalendarInfo1.DataBindingsForTasks.ParentTaskIdMember = "ParentTaskKey";
            this.ultraCalendarInfo1.DataBindingsForTasks.PercentCompleteMember = "TaskPercentComplete";

            this.ultraCalendarInfo1.DataBindingsForTasks.AllPropertiesMember = "AllProperties";
            this.ultraGanttView1.CalendarInfo = this.ultraCalendarInfo1;
        }

        private void ultraComboEditor1_ValueChanged(object sender, EventArgs e)
        {
            if (ultraComboEditor1.Value != null)
            {
                this.ultraGanttView1.Project = this.ultraGanttView1.
                    CalendarInfo.Projects[ultraComboEditor1.Value.ToString()];
            }
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            try
            {
                foreach (var task in ultraCalendarInfo1.Tasks)
                {
                    Debug.WriteLine("{0} taks has {1} duration.",task.Name,task.Duration);
                }
                
                this.projectTableAdapter.Update(database1DataSet.Project);
                this.tasksTableAdapter.Update(database1DataSet.Tasks);
            }
            catch (Exception ex)
            {
                Debug.WriteLine(ex.GetType());
                Debug.WriteLine(ex.Message);
            }
        }
    }
}
